Device = 24HJ128GP502
Declare Xtal = 79.23
TRISB = %0000000000000000


' Configure for internal 7.37MHz oscillator with PLL
' OSC pins are general purpose I/O
' 
    Config FBS = BWRP_WRPROTECT_OFF, BSS_NO_FLASH, BSS_NO_BOOT_CODE
    Config FSS = SWRP_WRPROTECT_OFF, SSS_NO_FLASH, RSS_NO_SEC_RAM
    Config FGS = GWRP_OFF, GCP_OFF
    Config FOSCSEL = FNOSC_FRCPLL, IESO_OFF
    Config FOSC = POSCMD_NONE, OSCIOFNC_ON, IOL1WAY_OFF, FCKSM_CSDCMD
    Config FWDT = WDTPOST_PS256, WINDIS_OFF, FWDTEN_OFF
    Config FPOR = FPWRT_PWR128, ALTI2C_OFF
    Config FICD = ICS_PGD1, JTAGEN_OFF
    
' Alphanmuneric LCD declares (Ensure these are placed before the Hitachi.inc file is inluded)
' Note that the alphanumeric LCD does not use the RW pin, therefore, this must be strapped to Gnd.
'    
    Declare LCD_DTPin = PORTB.12                ' Port and Pin where the LCD's data pins (D4 to D7) are attached
    Declare LCD_RSPin = PORTB.8                 ' Connects to the LCD's RS pin
    Declare LCD_ENPin = PORTB.9                 ' Connects to the LCD's EN pin  
    Declare LCD_Interface = 4                   ' The interface type to the LCD (4 or 8)
    Declare LCD_Lines = 2                       ' The amount of lines on the LCD (1, 2 or 4)
    Declare LCD_CommandUs = 2000                ' The delay required for commands within the LCD (in us)
    Declare LCD_DataUs = 100                    ' The delay required for data within the LCD (in us)

PLL_Setup(43, 2, 2, $0300)                      ' Configure the Oscillator to operate the device at 79.23MHz 
GoTo Main
Include "VarBeam.bas"
Include "Moonproc.bas"
Include "Sunmoon.bas"


Main:
DelayMS 1000
Cls
DelayMS 1000

Proc A_in_Deg (Floatin As Float),Float
Dim Fraction As Float
Dim Whole As Float
         Fraction = Modf(Floatin, Whole)
         Result = Fraction * 360
EndProc

DJD=40584.109375

T = DJD / 36525
A = 100.0021358 * T
B = A_in_Deg(A)  

Print At 1,1, "B=", Dec6 B       'correct answer 41.6189
Print At 2,1, "A=", Dec6 A       '111.115608
End        
