'****************************************************************
'*  Name    : VarBeam.BAS                                       *
'*  Author  : John F Drew VK5DJ                                 *
'*  Notice  : Copyright (c) 2006 [select VIEW...EDITOR OPTIONS] *
'*          : All Rights Reserved                               *
'*  Date    : 17/03/2006                                        *
'*  Version : 1.0                                               *
'*  Notes   : Contains the variables and constants              *
'*          : for the rotator                                   *
'****************************************************************
Symbol Pi=3.1415927                     'constants used in astronomical calculations
Symbol PiBy2= 1.5707963
Symbol TPI =   6.283185308 
Symbol Rad = 0.01745329252                                                                                                 
Symbol Deg = 57.29577951 
Symbol CircleDeg = Deg / 360            'convert radians to deg and make part of circle
Symbol Small = 0.00000000000000001
Symbol Speedlight = 6.67128190396       '2000000/299792.458 conversion to HZ and speedlight

'variables
'Dim _FP_FLAGS As    Byte System

Dim YearFract       As Float             'proportion of a year to calc Nutat
Dim Second          As Byte              'define the clock variables in interrupt routine
Dim Minute          As Byte
Dim Hour            As Byte
Dim Day             As Byte              
Dim Date            As Byte              'this is day number in month, is translated to Day
Dim Year            As Word
Dim Month           As Byte
Dim Years           As Dword             'time and date variables for calculation of moon
Dim Months          As Dword
Dim Hours           As Float
Dim Days            As Float
Dim Mins            As Float
Dim Seconds         As Float
Dim YearOffset      As Byte              'used in calculation of Nutat to access edata

'used in calendar routines
Dim Convert         As Byte
Dim Temp_Convert    As Byte              'Temp variable for the bcd bin routines
Dim ds1307_address  As Byte              'address of variable in DS1307
Dim SecondStore     As Byte              'used to detect change in seconds
Dim TempHr          As Byte              'used in calendar and GPS
Dim TempMin         As Byte
Dim TempSec         As Byte
Dim TempDay         As Byte
Dim TempMonth       As Byte
Dim TempYear        As Byte

'********************************        import from moonmaths

Dim Jday            As Float             'Julian day 
Dim Jcent           As Float             'Julian centuries
Dim T2              As Float             'temp dword for calculations   'changed from Dword
Dim T3              As Dword             'temp dword
Dim TF1             As Float             'temp float 
Dim TF2             As Float             'temp float 
Dim TF3             As Float             'temp float 
Dim CountLimit      As Byte              'in update to fix 60,24,12 numbers in time/date
Dim TF4             As Float             'temp float 
Dim Fx              As Float             'effectively parameters 
Dim Fy              As Float             'effectively parameters 
Dim Fz              As Float             'effectively parameters 
Dim Result          As Float             'result of functions
Dim Glat            As Float             'lat of observer
Dim GlatR           As Float             'latitude in radians
Dim Glong           As Float             'lat and long of observer
Dim lo              As Float             'the following are for internal calcs
Dim bm              As Float
Dim gp              As Float
Dim rm              As Float
Dim xg              As Float
Dim yg              As Float
Dim zg              As Float
Dim ECL             As Float
Dim xe              As Float
Dim ye              As Float
'Dim ZeTemp          As Float            'doesnt seem to be used
Dim sdia            As Float
Dim RtAsc           As Float
Dim Decl            As Float
Dim lst             As Float
Dim T1              As Byte              'temp byte variable
Dim Xtop            As Float
Dim Ytop            As Float
Dim Ztop            As Float
Dim dectop          As Float
Dim SI              As Float             'used in calc of el and az and FNatn3
Dim Dummy1          As Byte              'used in test for negative numbers
Dim Dummy2          As Byte
Dim Dummy3          As Byte
Dim CO              As Float             'used in calc of el and az and FNatn3
Dim TH              As Float             'temp var in FNatn3

Dim HRangle         As Float             'hr angle of local site  
Dim Elevation       As Float             'elevation for moon
Dim Azimuth         As Float             'azimuth of moon

' ****************** end of import

Dim MA              As Float             'this batch are used in sun
Dim Epsilon         As Float  
Dim Lambda          As Float
Dim T1a             As Byte
Dim Tick            As Bit               'controls the moon/sun calculation every sec added version 6.00

'**************************************
 Dim Flag0     As    Bit                 'this group are used in new sunmoon routines
 Dim Flag1     As    Bit
 Dim Flag3     As    Bit
 Dim Flag4     As    Bit
 Dim Flag5     As    Bit
 Dim Flag7     As    Bit 
 Dim Flag11    As    Bit
 Dim SW3       As    SByte
 Dim Mn        As    Byte
 Dim Mn1       As    Byte
 Dim XMn       As    Byte
 Dim Dy        As    Float
 Dim XDy       As    Float
 Dim Yr        As    Dword    
 Dim Yr1       As    Dword    
 Dim A5        As    Dword
 Dim A1        As    Float
 Dim A         As    Float
 Dim B5        As    SDword
 Dim B         As    Float
 Dim C         As    Float
 Dim C5        As    Dword
 Dim D5        As    Dword
 Dim TempB1    As    Byte
 Dim TempW1    As    Dword
 Dim TempF1    As    Float
 Dim TempF2    As    Float
 Dim TempF3    As    Float
 Dim TempF4    As    Float
 Dim TempF5    As    Float 
 Dim DJD       As    Float
 Dim XDJD      As    Float
 Dim JD        As    Float
 Dim T         As    Float
 Dim R         As    Float
 Dim R1        As    Float
 Dim SN        As    Float
 Dim XD        As    Float
 Dim XM        As    Float
 Dim XS        As    Float
 Dim XD1       As    Float
 Dim XM1       As    Float
 Dim XS1       As    Float
 Dim X         As    Float
 Dim T0        As    Float
 Dim GTM       As    Float
 Dim TIM       As    Float
 Dim CPHI      As    Float
 Dim PHI       As    Float
 Dim SPHI      As    Float
 Dim SY        As    Float
 Dim Y         As    Float
 Dim CY        As    Float
 Dim SX        As    Float
 Dim CX        As    Float
 Dim SQ        As    Float
 Dim Q         As    Float
 Dim CQ        As    Float
 Dim CPtemp    As    Float
 Dim P         As    Float
 Dim W         As    Float
 Dim GST       As    Float
 Dim LNG       As    Float 
 Dim U         As    Float
 Dim CU        As    Float 
 Dim SU        As    Float
 Dim Dummy4    As    Byte               'to fix variables across boundary
' Dim Dummy5    As    Byte 
 Dim RP        As    Float
 Dim RCP       As    Float
 Dim RSP       As    Float
 Dim DX        As    Float
 Dim TDX       As    Float
 Dim HT        As    Float
 Dim EHP       As    Float              'horizontal parallax for moon
 Dim LS        As    Float
 Dim MS        As    Float
 Dim S         As    Float
 Dim B1        As    Float
 Dim C1        As    Float
 Dim D1        As    Float
 Dim E1        As    Float
 Dim H1        As    Float
 Dim DL        As    Float
 Dim DR        As    Float 
 Dim LSN       As    Float
 Dim NU        As    Float 
 Dim RSN       As    Float 
 Dim EA        As    Float 
 Dim DLA       As    Float
 Dim M         As    Float
 Dim TNU2      As    Float 
 Dim EPS       As    Float
 Dim EPSR      As    Float
 Dim DEPS      As    Float 
 Dim CEPS      As    Float
 Dim SEPS      As    Float
 Dim EPS1      As    Float
 Dim TY        As    Float
 Dim TLS       As    Float
 Dim NM        As    Float
 Dim LD        As    Float
 Dim MD        As    Float
 Dim TNM       As    Float
 Dim TLD       As    Float
 Dim DPSI      As    Float
 Dim Y1        As    Float
 Dim R2        As    Float
 Dim PR        As    Float
 Dim TR        As    Float
 Dim YD        As    Float
 Dim LSND      As    Float               'apparent longitude
 Dim M1        As    Float
 Dim M2        As    Float
 Dim M3        As    Float
 Dim M4        As    Float
 Dim M5        As    Float
 Dim M6        As    Float
 Dim DEx1      As    Float
 Dim F         As    Float
 Dim N         As    Float
 Dim SAtemp    As    Float
 Dim SBtemp    As    Float
 Dim SC        As    Float
 Dim E         As    Float
 Dim E2        As    Float
 Dim DEx2      As    Float
 Dim DEx3      As    Float
 Dim DEx4      As    Float
 Dim MDx3      As    Float
 Dim L         As    Float
 Dim MDx2      As    Float
 Dim MDx4      As    Float
 Dim Fx2       As    Float
 Dim Fx3       As    Float
 Dim LAM       As    Float
 Dim MSx2      As    Float
 Dim G         As    Float
 Dim W1temp    As    Float
 Dim W2temp    As    Float
 Dim BET       As    Float 
 Dim HP        As    Float              'horizontal parallax for sun
 Dim DataA     As    Byte               'used in Nutat
 Dim DataB     As    Byte               'used in Nutat
' Dim Gap       As    Word              'used in Nutat
 Dim TempAdd   As    Word               'used in update

'**************************************

Dim AntennaAZ       As Float            'degrees to serial and display  AZ
Dim AntennaEL       As Float            'degrees to serial and display  EL
Dim ADvalue         As Float            'AD conversion value after adjustment
Dim ConvertDegrees  As Float            'divisor to convert raw number to degrees

Dim MultipleAZ      As Float            'conversion number dependent on 360 or more degrees for AZ pot
Dim MultipleEL      As Float            'conversion number dependent on 360 or more degrees for EL pot

Dim RawdataInA      As Word             'has value of encoder -incoming stream from antenna  AZ
Dim HoldDataInA     As Word             'in case data in times out (provides reference value AZ
Dim RawdataInE      As Word             'has value of encoder -incoming stream from antenna  EL
Dim HoldDataInE     As Word             'in case data in times out (provides reference value AZ
Dim LoopCounterA    As Byte             'comes in from AZ/EL, number of loops in count (<16)
Dim HoldLoopA       As Byte             'in case data times out (provides backup loop count) 
Dim LoopCounterE    As Byte             'comes in from AZ/EL, number of loops in count (<16)
Dim HoldLoopE       As Byte             'in case data times out (provides backup loop count) 
Dim TDWord          As SDword           'used in printroutine as a temp
Dim TimecountAZ     As Byte             'counts down and if zero no delay to change beam AZ direction
Dim TimecountEL     As Byte             'counts down and if zero no delay To change beam EL direction

Dim CheckA          As Word             'checksum in data from antenna  AZ
Dim CheckE          As Word             'checksum in data from antenna  EL
Dim TempCheck       As Word             'temp checksum in ReceiveAZ and ReceiveEL
Dim T1W             As Word             'used to bring data in from comp
Dim T2W             As Word             'used to bring data in from comp

Dim ADazDeg         As Float            'total AZ degrees covered by potentiometer
Dim ADelDeg         As Float            'total EL degrees covered by potentiometer
Dim PrintValA       As Word             'used in printout of pot calcs AZ
Dim Lastmove        As Byte             'remembers last motor movement
Dim PrintValE       As Word             'used in printout of pot calcs EL

Dim FunctionA       As Byte             'carries A (Az) or M (setup mode)
Dim FunctionE       As Byte             'carries E (El) or M
Dim Compin          As Byte             'data from computer and used as data in from switches
Dim Compin2         As Byte             'data from computer

Dim NegOffset       As Byte             'degrees below horizon from 0
Dim ADelOffset      As Byte             'number of degrees of offset for EL pot
Dim ADazOffset      As Byte             'number of degrees of offset for AZ pot 
Dim DelaySecs       As Byte             'value of timedelay in secs
Dim OpMode          As Byte             '1=az, 2=el, 4=AZ serial, 8=EL serial
Dim BrakePres       As Byte             'in remote control 1= brake present, 0 = not
Dim Brakecount      As Byte             'delay before actuating brake
Dim BrakeFlag       As Byte             'when 1 apply the brake, otherwise 0=timing phase
Dim Temp1           As Byte             'for general use in one routine at a time
Dim Temp2           As Byte
Dim Temp3           As Byte

Dim Brake           As Bit              '0=no brake, 1=brake present
Dim EndTravel       As Bit              '0=north stop, 1=south stop
Dim TestFlag        As Bit              'used to determine if timer should be set
Dim Left            As Bit              'direction indicator bits used in manual and auto
Dim Right           As Bit
Dim Up              As Bit
Dim Down            As Bit
Dim AZopmode        As Bit              'determines the AZ mode for the unit 1=true
Dim ELopmode        As Bit              'determines the EL mode for the unit 1=true
Dim SerialmodeA     As Bit              'determines the Serial mode for Azimuth 1=true, 0=Pot mode
Dim SerialmodeE     As Bit              'determines the Serial mode for Elevation 1=true, 0=Pot mode
Dim ADel360         As Bit              'flag for + or -ve offset on pot for elevation
Dim ADaz360         As Bit              'flag for + Or -ve offset on pot for azimuth
Dim DidControl      As Bit              'set if one or more relays were fired
Dim Mode            As Byte             'used in update of time and date
Dim StopGapA        As Float            'hysterisis value Azimuth                                  
Dim StopGapE        As Float            'hysterisis value Elevation

Dim DispUpdate      As Word             'used in update function
Dim DoControlFlag2  As Bit              'used to set delay
Dim BtnVar0         As Byte             'button variable in update for switchup
Dim BtnVar1         As Byte             'button variable for switchdown
Dim BtnVar2         As Byte             'button variable in update for switchright
Dim BtnVar3         As Byte             'button variable for switchleft
Dim ButtonRight     As Bit              'indicates if right button pressed in update
Dim ButtonLeft      As Bit              'indicates if left button pressed in update
Dim ButtonUp        As Bit              'indicates if up button pressed in update
Dim ButtonDown      As Bit              'indicates if down button pressed in update
Dim PrintFloat      As Float            'for printing floats
Dim Address         As Word             'address of strings in print routine
Dim CompCounter     As Word             'counter in brake routines

Dim AzimuthPlus     As Float            'allow for hysteresis
Dim AzimuthMinus    As Float            'allow for hysteresis
Dim ElevationPlus   As Float            'allow for hysteresis
Dim ElevationMinus  As Float            'allow for hysteresis

Dim TempAveF1       As Float            'temp used in averaging results
Dim TempAveF2       As Float            'temp used in averaging results
Dim TempAveWord     As Word             'temp used in averaging

Dim MoonHalf        As Byte             'used in direction routine
Dim AntennaHalf     As Byte             'used in direction routine
Dim AveragingStat   As Byte             'number of loops for stationary averaging
Dim AveragingMov    As Byte             'number of loops for moving averaging
Dim AZencoder       As Byte             '0=10 bit, 1=12 bit, 2=14bit, 3=16bit
Dim ELencoder       As Byte             '0=10 bit, 1=12 bit, 2=14bit, 3=16bit, 4= SCA16T
Dim AZconversion    As Float            'converts raw reading to degrees
Dim ELconversion    As Float            'converts raw reading to degrees
Dim PlusAZ          As Byte             'flag holds whether to add (1)or subt (0) offset  AZ
Dim PlusEL          As Byte             'flag holds whether to add (1)or subt (0) offset  EL
Dim TempWord        As Word             'an available temporary word in any routine
Dim AZ_Lstop        As Word             'azimuth software lower stop (note edata number reps 2 degs)
Dim AZ_Hstop        As Word             'azimuth software high stop (note edata number reps 2 degs)  
Dim EL_Lstop        As Float            'elevation software lower stop (note edata number reps 1 deg)
Dim EL_Hstop        As Word             'elevation software high stop (note edata number reps 2 degs)  
Dim HitStop         As Byte             'flag to light LED if 1 to indicate limit switch
Dim LastDirAZ       As Bit              'saves last direction for delay purposes 0=L, 1=R
Dim LastDirEL       As Bit              'saves last direction for delay purposes 0=D, 1=U 
Dim Taz_Lstop       As Dword            'next three temp variables used in software stops routine
Dim Taz_Hstop       As Dword
Dim TfloatOutA      As Float 
Dim ObjectType      As Byte             'used to define "M" or "S" in data out to VGA screen
Dim VGAactive       As Byte             'is the VGA active 1=yes
Dim ClearAZELflag   As Bit              'first external input resets AZ and EL to zero
Dim MAXInUse        As Byte             '0= +5V for CTS and DTR, 1=through MAX232
Dim MoveBeam        As Byte             'an input from VK3UM to move the beam
Dim WaitChr         As Byte             'flag used in computer data in to indicate AZ/EL or Time
Dim EMEinUse        As Byte             'flag to indicate 0=internal cntr of auto 1=EMEplanner cntrl
Dim HoldMoveBeam    As Byte             'memory in "do direction" to stop chatter
Dim InputDevice     As Byte             'if 1 then using an SEI for Doug
Dim REFinUse        As Byte             'if 1 then use refraction correction
Dim MonthChange     As Byte             'if 1 then checks NUTAT (gets updated on switch on/monthchange)
Dim RelayMode       As Byte             'choose old relay wiring=0, new relay wiring=1, Hbridge = 2, PWM = 3
Dim CalibrateAZ     As Float            'added to readout of sensor in degrees to calibrate
Dim CalibrateEL     As Float            'added to readout of snesor in degrees to calibrate
Dim PrelimAZ        As Float            'stores unadjusted sensor values
Dim PrelimEL        As Float            
Dim Noprint         As Byte             'after a date/time set it doesn't print false values
Dim MaxVal          As Byte             'maximum options in update of a byte 
Dim Brakestop       As Byte
Dim ParkVar         As Byte             'stores if park is set 0=not set 1=set
Dim Dummy           As Byte             'used to clear input buffer from computer
Dim DefinitionA     As Dword            '1024 or 4096 or 16384 or 65536 used to set multiplier for AZ encoders
Dim DefinitionE     As Dword            '1024 or 4096 or 16384 or 65536 used to set multiplier for EL encoders

'Doppler variables

Dim EarthVel        As Float             'rotational velocity at a latitude
Dim MoonVel         As Float             'moon velocity due rotation of earth
Dim Doppler         As Float             'Doppler shift as a float
Dim BandVal         As Byte              'number for storage in eedata for band
Dim PrintDoppler    As Byte              'used in print routine 0=print doppler >0 print sun/moon
Dim DopplerDW       As SDword            'doppler shift for printing
Dim Band            As Float             'band for calculation of shift
Dim MoonDistCurrent As Float             'distance of moon currently
Dim MoonDistPast    As Float             'distance of moon at last calculation
Dim AzimuthSin      As Float             'sine of azimuth of moon
Dim TotalVel        As Float             'velocity of moon movement and rotation of earth
Dim ElevationCos    As Float             'cos of elevation of moon
Dim MoonChange      As Float             'diff in distance over two readings
Dim HoldEHP         As Float             'store ehp and look for change
Dim TempHoldEHP     As Float             'working temp
Dim HoldDJD         As Float             'store date/time
Dim TimeDiff        As Float             'evaluate time diff between changes of EHP
Dim TempEHP         As Float             'working variable 
Dim AveDistChange   As Float             'an averaging variable for moon distance change
Dim MoonLoops       As Byte              'counter of loops through average distance

'variables for GPS

Dim AcquiredA       As Byte              'if A then sats acquired
Dim GPSstr As String * 61
Dim TempDegW        As Word              'used in conversion to decimal degrees
Dim LatDir          As Byte              'Latitude N or S
Dim LongDir         As Byte              'Longitude E or W
Dim TwoStr          As String *2
Dim ThreeStr        As String *3
Dim FourStr         As String *4
Dim Counter1        As Byte
Dim TempFloat       As Float             'used in extraction routine
Dim TempByte1       As Byte              'as above
Dim Pos             As Byte              'locate posn of comma

'variables for SCA16T
Dim InclineOffset   As Word              'actual value of offset at 0 degrees (default 1024)   
Dim SCA61present    As Byte              'if 0 not present if 1 then present

'variables used in the direction routines to fix hysteresis
Dim AntennaBelow    As Bit               'gets beam into centre of hysteresis
Dim AntennaAbove    As Bit
Dim AntennaRight    As Bit               'gets beam into centre of hysteresis
Dim AntennaLeft     As Bit
Dim TestFlagAZ      As Bit
Dim TestFlagEL      As Bit

'variables for Yaesu input
Dim AZ              As Word              'used when accessing the GS232A interface
Dim EL              As Word 

'variables for RunOn allowance
Dim RunOnMinus      As Float
Dim RunOnPlus       As Float
Dim RunOnAZ         As Float 
Dim RunOnEL         As Float 

'variables for local time printing
Dim TimeOffset      As Byte             'offset stored in float as fract in hrs
Dim LocalMin        As Byte             'dont need localsecond - use UTC
Dim LocalHr         As Byte
Dim Bandword        As Word             'displays band of doppler
Dim PrintDop        As Bit              'flag whether to print doppler
Dim Halfhour        As Bit              'if 1 then 1/2 hour in UTC offset

'checksum and remote bypass of auto/manual switch
Dim CheckSumIn      As Word             'checks that incoming data from computer good
Dim AutoSwBypass    As Byte             'approves external control of Auto/Man Switch 1=active
Dim Checking        As Byte             'approves whether hardware accepts checksum

'added in 4 line
Dim DeclinationV    As Float            'prints declination on first line, default Dec Tropo
Dim TempW2          As Word             'used in print routine as temp
Dim DeclSteer       As Byte             'steers the assignment of declination

'Hbridge variables
Dim MinMotor        As Byte             'minimum motor speed
Dim MotorRatio      As Byte             'ratio speed changes in last 10 degrees
Dim Hbridge_out     As Byte             'holds I2C address to Hbridge
Dim Speed           As Byte             'calculated speed of motor
Dim ELdiff          As Word             'used in speed control (Movement)
Dim AZdiff          As Word             'used in speed control (Movement)

'PWM variables
Dim TempSpeed       As Byte             'holds temp speed calc in PWM
Dim TempSpeed2      As Byte
Dim LeftRightFlag   As Bit              'steers to correct routine
Dim UpDnFlag        As Bit              'steers to correct routine
Dim MenuFlag        As Bit              'stores that a menu is required
Dim MaxMotor        As Byte             'stores max motor

'Display choice variable
Dim DisplayType     As Byte              'when 1=difference display, 0=standard AZ/EL
Dim AZdisplay       As Float             'azimuth difference heading
Dim ELdisplay       As Float             'elevation difference heading
